/*
 * hz.c
 *
 * All rights reserved. Copyright (C) 1994,1998 by NARITA Tomio
 */

#include <import.h>
#include <encode.h>
#include <unimap.h>
#include <big5.h>
#include <begin.h>
#include <hz.h>

public void EncodeHz( i_str_t *istr, int head, int tail,
		     char codingSystem, boolean_t binary )
{
  int idx, attr;
  ic_t ic;
  char cset;
  boolean_t asciiMode = TRUE;

  for( idx = head ; idx < tail ; idx++ ){
    cset = istr[ idx ].charset;
    ic = istr[ idx ].c;
    attr = (int)istr[ idx ].attr << 8;
    if( BIG5 == cset )
      ic = BIG5toCNS( ic, &cset );
#ifndef MSDOS /* IF NOT DEFINED */
    else if( UNICODE == cset )
      ic = UNItoGB( ic, &cset );
#endif /* MSDOS */
    if( cset < PSEUDO ){
      if( ASCII == cset ){
	if( FALSE == asciiMode ){
	  asciiMode = TRUE;
	  EncodeAddChar( attr, (ic_t)'~' );
	  EncodeAddChar( attr, (ic_t)'}' );
	}
	EncodeAddChar( attr, ic );
	if( (ic_t)'~' == ic )
	  EncodeAddChar( attr, (ic_t)'~' );
      } else if( GB2312 == cset ){
	if( TRUE == asciiMode ){
	  asciiMode = FALSE;
	  EncodeAddChar( attr, '~' );
	  EncodeAddChar( attr, '{' );
	}
	EncodeAddChar( attr, MakeByte1( ic ) );
	EncodeAddChar( attr, MakeByte2( ic ) );
      } else {
	if( FALSE == EncodeAddInvalid( attr, ic, cset ) )
	  break;
      }
    } else if( FALSE == EncodeAddPseudo( attr, ic, cset, binary ) ){
      break;
    }
  }
}
